<script setup>
// imports
import { ref } from "vue";
import axios from "axios";

// variables
let rows = ref([]);
let columns = ref([
  {
    name: "title",
    label: "Title",
    align: "left",
    field: "title",
  },
  {
    name: "completed",
    label: "Completed",
    align: "left",
    field: "completed",
  },
]);
let form = ref({
  userId: 1,
  title: null,
  completed: false,
});
let btnLoadingState = ref(false);
let selectedRow = ref({});
let deleteBtnLoadingState = ref(false);

// function for fetching todo list
const getTodos = () => {
  axios.get("https://jsonplaceholder.typicode.com/todos").then((response) => {
    rows.value = response.data;
  });
};
getTodos();

// function for inserting a new todo task
const addTodo = () => {
  btnLoadingState.value = true;
  axios
    .post("https://jsonplaceholder.typicode.com/todos", form.value)
    .then((response) => {
      if (response.status === 201) {
        console.log(response.data);
        const { userId, title, completed, id } = response.data;
        rows.value.unshift({ userId, id, title, completed });
        form.value.title = null;
      }
      btnLoadingState.value = false;
    });
};

// function for selecting a row
const onRowClick = (evt, row) => {
  selectedRow.value = row;
  form.value.title = row.title;
  console.log(row);
};

// function for updating a selected row/todo task
const updateTodo = () => {
  btnLoadingState.value = true;
  axios
    .put(`https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`, {
      title: form.value.title,
    })
    .then((response) => {
      if (response.status === 200) {
        let index = rows.value.findIndex(
          (row) => row.id === selectedRow.value.id
        );
        rows.value[index].title = response.data.title;
        form.value.title = null;
        selectedRow.value = {};
      }
      btnLoadingState.value = false;
    });
};

// function for deleting selected row/todo task
const deleteTodo = () => {
  deleteBtnLoadingState.value = true;
  axios
    .delete(
      `https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`
    )
    .then((response) => {
      if (response.status === 200) {
        rows.value = rows.value.filter(
          (row) => row.id !== selectedRow.value.id
        );
        form.value.title = null;
        selectedRow.value = {};
      }
      deleteBtnLoadingState.value = false;
    });
};
</script>

<template>
  <q-page class="justify-center row items-center">
    <section
      style="width: 40rem; border-radius: 3rem"
      class="shadow-1 bg-white"
    >
      <div class="todo-form-container">
        <p
          class="text-h4 text-weight-bold text-center q-mt-lg"
          style="letter-spacing: 1px; text-shadow: 2px 2px #b3e5fc"
        >
          <span class="text-primary">TO</span>DO APP
        </p>
        <q-form
          @submit="!selectedRow.id ? addTodo() : updateTodo()"
          class="q-mb-md q-pa-md bg-white todo-form"
        >
          <q-input v-model="form.title" label="Input Field" />

          <div class="row justify-center items-center q-mt-md">
            <q-btn
              :loading="btnLoadingState"
              type="submit"
              :label="!selectedRow.id ? 'Submit' : 'Update'"
              color="primary"
              style="border-radius: 3rem"
            />
            <q-btn
              :loading="deleteBtnLoadingState"
              v-if="selectedRow.id"
              @click="deleteTodo()"
              class="q-ml-md"
              label="Delete"
              color="negative"
              style="border-radius: 3rem"
            />
          </div>
        </q-form>
      </div>
      <div class="bg-light-blue-2 q-pa-md todo-table-container">
        <q-table
          class="todo-table no-shadow"
          :rows="rows"
          :columns="columns"
          row-key="name"
          @row-click="onRowClick"
        />
      </div>
    </section>
  </q-page>
</template>

<style scoped>
.todo-form-container {
  border-radius: 3rem;
  margin-bottom: -1rem;
  position: relative;
}
.todo-form-container::before {
  content: "";
  width: 50%;
  height: 50%;
  position: absolute;
  right: 0;
  bottom: 0;
  background-color: #b3e5fc;
  /* z-index: -1; */
}
.todo-form {
  border-radius: 3rem;
  widows: 100%;
}
.todo-table-container {
  border-top-left-radius: 3rem;
  border-bottom-left-radius: 3rem;
  border-bottom-right-radius: 3rem;
}
.todo-table {
  background-color: inherit;
}
</style>
